package pl.net.linux.krzak.kchat.applet;
/*****************************/
/* kChat v2.0pre3	     */
/* krzak@linux.net.pl        */
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.net.Socket;

public class kChatNet extends Thread {
    Socket         clientS    = null;
    BufferedReader br         = null;
    PrintWriter    pw         = null;
    kChatApplet    applet     = null;
    kChatProtocol  protocol   = null;

    public kChatNet(String hosttmp,String port,kChatApplet a) {
    super("kChatNet");
    applet = a;
    try {
    if ((port == null) || (port.equals(""))) { port = new String("1979"); }
    clientS = new Socket(hosttmp,new Integer(port).parseInt(port));
    br = new BufferedReader(new InputStreamReader(clientS.getInputStream()));
    pw = new PrintWriter(new BufferedOutputStream(clientS.getOutputStream(), 1024), false);
    } catch (IOException e) {
	applet.chanWnd.appendText(applet.TXT[18],"red");
	e.printStackTrace();
	}
    }

    public void run()
    {
    try {
	String liniaWy = new String();
	String liniaWe = new String();
	protocol = new kChatProtocol(applet);
	while ((br!=null) && ((liniaWe = br.readLine()) != null)
)
	    {
	    if (liniaWe != null)
		protocol.parse(liniaWe);
	    }
//	applet.chanWnd.appendText(applet.TXT[18],"red");
	}
 catch (IOException e)
  {
	    try {
	    if (br !=null) {
		br.close();
		br=null;
		}
	    if (pw !=null) {
		pw.close();
		pw=null;
		}
	    if (clientS !=null) {
		clientS.close();
		clientS = null;
		}
	    } catch (IOException ex) { ex.printStackTrace(); }
	    e.printStackTrace();
	    }
    }

    public void disconnect() {
	try {
	if (pw != null)
	    send("*CLOSE");
	if (br !=null) {
	    br.close();
	    br=null;
	    }
	if (pw !=null) {
	    pw.close();
	    pw=null;
	    }
	if (clientS !=null) {
	    clientS.close();
	    clientS = null;
	    }
	} catch (IOException e) {
	    e.printStackTrace();
	    }
    }

    public void send(String data) {
	if ((data != null)&&(pw!=null)){
	    data.trim();
	    pw.println(data + "\r\n");
	    pw.flush();
	    }
    }

    public void setApplet(kChatApplet a) { applet = a; }


}